<?php
// config'      base
// (!) config           

/* by RGBeast <rgbeast@flede.org> */
function addslashes_array($array) {
  return is_array($array) 
   ? array_map('addslashes_array', $array) 
   : addslashes($array);
}

/* by PMA */
function work_array(&$array, $func, $keys_too) {
 static $rec_counter = 0;
 if (++$rec_counter > 10) {
  exit('possible middle recursion attack');
 }
 
 foreach ($array as $k => $v) {
  if (is_array($v)) work_array($array[$k], $func, $keys_too);
  else $array[$k] = $func($v);
 
  if ($keys_too && is_string($k)) {
   $new_key = $func($k);
   if ($new_key != $k) {
    $array[$new_key] = $array[$k];
    unset($array[$k]);
   }
  }
 }
 
 $rec_counter--;
}

function myaddslashes($str){
 if (!get_magic_quotes_gpc()) $str = addslashes_array($str);
 return $str;
}

if (!function_exists("mb_strtolower")) {
 function mb_strtolower($str){
  $str = strtolower($str);
  return $str;
 }
}
if (!function_exists("mb_strtoupper")) {
 function mb_strtoupper($str){
  $str = strtoupper($str);
  return $str;
 }
}

function m_ob_gzhandler() {
 global $pageval, $contentLength, $pagetime, $contentType, $etag;
 $p2=gzencode($pageval,9);
 $p1=ob_gzhandler($pageval,9);
 $contentLength=strlen($p2);
 cacheh(1,$pagetime,$etag, $contentLength,$contentType,true);
 return $p1;
}

function cacheh($type,$time,$etag=false, $contentLength=0, $contentType="text/html; charset=windows-1251", $vis=false, $maxage=0) {
 global $since, $match, $h304, $varrvis, $uri;
 $ccontrol="no-store, no-cache, must-revalidate, pre-check=0, post-check=0, max-age=0";
 $modify=gmdate("r")." GMT";
 if (1==$type) {
  $ccontrol="private, max-age=$maxage";
  $modify=gmdate("r", $time)." GMT";
 }
 if ($etag) header("Etag: $etag");
 header("Cache-Control: $ccontrol");
 header("Expires: ".gmdate("r")." GMT");
 if ($contentType) header("Content-Type: $contentType");
 header("Last-Modified: ".$modify);
 if ($vis) {
  foreach(headers_list() as $ke=>$va) {
    $varrvis[$ke+1]=$va;
  }
  $varrvis["hsent"]=headers_sent();
  $_SESSION["varrvis"]=$varrvis;
 }
 if ($since && $since==$time && (!$match || $match==$etag)) {
  if ($vis) {
   $varrvis[]=$h304; // :    
   $_SESSION["varrvis"]=$varrvis;
  }
  header($h304);
  exit;
 }
 else {
  /* etag write */
  $normuri = addslashes(urldecode($uri));
  $host = addslashes($_SERVER['HTTP_HOST']);
  $c_all = 1;
  $c_cookie = (count($_COOKIE)) ? 1 : 0;
  $c_robots = (preg_match("/robot/i", $_SERVER['HTTP_USER_AGENT'])) ? 1 : 0;
  $sql="insert ignore into `pages` (`host`, `name`) values ('$host', '$normuri')";
  mysql_query($sql);
  $sql="update `pages` set `etag`='$etag', `time`='$time', 
   `c_all`=`c_all`+$c_all, `c_cookie`=`c_cookie`+$c_cookie, `c_robots`=`c_robots`+$c_robots
   where `host`='$host' and `name`='$normuri'";
  mysql_query($sql);
  /* etag write end */
  if ($contentLength) {
   if ($contentLength>2000) {
//     (  )
    ob_start("ob_gzhandler");
   }
   else header("Content-length: $contentLength");
  }
 }
}

function mht($s) {
 $s=StripSlashes($s);
 $s=str_replace("'","&#39;",$s); // sql
 $s=str_replace("\"","&quot;",$s);
 $s=preg_replace("/(\r?\n){3,}/i","\n\n",$s);
 $s=str_replace("<","&lt;",$s); // 
 return($s);
}

if (!function_exists("apache_request_headers")) {
 if (function_exists("getallheaders")) {
  function apache_request_headers(){
   getallheaders();
  }
 }
 else $apache="cgi";
}

$calc="SQL_CALC_FOUND_ROWS";
$foundrows="SELECT FOUND_ROWS()";
$h304="HTTP/1.x 304 Not Modified";
$h404="HTTP/1.x 404 Not Found";
$match=""; $since=""; $varr=array(); $varrvis=array();
if (array_key_exists("HTTP_HOST",$_ENV)) $varr =& $_ENV;
if (array_key_exists("HTTP_HOST",$_SERVER)) $varr =& $_SERVER;
if (isset($varr["HTTP_IF_NONE_MATCH"])) $match=$varr["HTTP_IF_NONE_MATCH"];
$match=trim(strval($match));
if (isset($varr["HTTP_IF_MODIFIED_SINCE"])) $since=$varr["HTTP_IF_MODIFIED_SINCE"];
$since=explode(";",$since);
$since=strtotime(trim($since[0]));

foreach($varr as $ke=>$va) {
 if (preg_match("/^HTTP\_/i",$ke) && !preg_match("/COOKIE/i",$ke)) 
  $varrvis["$ke"]=$va;
}
$varrvis["Response"]="==========================================";

$ip0="";
if(isset($varr["REMOTE_ADDR"]))
 $ip0 = $varr["REMOTE_ADDR"];
elseif (@getenv("REMOTE_ADDR") )
 $ip0 = @getenv("REMOTE_ADDR");

$host=$varr["HTTP_HOST"];
$hostcn=preg_replace("/^www\./","",$host);
$referer=@$varr["HTTP_REFERER"];
$uri=$varr["REQUEST_URI"]; 

$agent=false;
$useragent=strtolower($varr["HTTP_USER_AGENT"]);
$agent=(strpos($useragent,"opera")===false && strpos($useragent,"msie")!==false)?false:true;
$agent=(strpos($useragent,"opera")===false)?$agent:"opera";


if (strpos(mb_strtolower(getenv('OS')),"windows")===0) $slash="\\";
else $slash="/"; //   ,  php    "c:/infodisk/apache2"
$myself=@$_SERVER["SCRIPT_FILENAME"]; //  __FILE__,   config      ( __FILE__     config)
$myself=str_replace("\\","/",$myself); 
$mypath=realpath(dirname($myself)); //  ,   ,  configbase  require!!)
$myfile=explode("/",$myself);
$myfile=array_pop($myfile);

$pathacc=realpath(dirname(__FILE__)); //,   configbase.php
$pathacc=str_replace("\\","/",$pathacc);

$sitedir=explode("/",$pathroot);
$sitedir=array_pop($sitedir);

$docroot=$varr["DOCUMENT_ROOT"];
$docroot=str_replace("\\","/",$docroot);
// pathroot   -  http://dn.ir2.ru
if ($pathroot==$docroot || $sitedir == 'allo-irkutsk.ru') {
 $hpref=""; $uri_prfx="";
 $glav=""; $uri_prfxs="/";
}
//     
else {
 $hpref="{$sitedir}/"; $uri_prfx="/{$sitedir}"; $uri_prfxs="/{$sitedir}/";
 $glav="<a href=\"/infodisk/\"></a> &bull; ";
}

$ho=array("s3000461"=>"allz", "a100306"=>"allz", "a200389"=>"allz", "cust100204"=>"allz", "ir2"=>"dino", "borona"=>"d-host");
$bdprefix="";
$hosting="infodisk";
foreach ($ho as $k=>$v) {
 if (false!==strpos($mypath,"/$k/")) {
  $bdprefix="{$k}_";
  $hosting="$v";
 }
}

$prefixbd=$bdprefix;
$bdpref=$bdprefix;
$bdvy="{$bdpref}vysota";
$bddn="{$bdpref}dn";
$bdi4="{$bdpref}i4";
$bdi2="{$bdpref}i4";
$folders=array("dn.ir2.ru", "irkutsk.ir2.ru", "3mir.net.ru", "vostsibspravka.ru", "adres", "rost");
$doctype="<!DOCTYPE HTML PUBLIC '-//W3C//DTD HTML 4.01 Transitional//EN' 'http://www.w3c.org/TR/1999/REC-html401-19991224/loose.dtd'>\n";
$meta="<meta http-equiv='Content-Type' content='text/html; charset=windows-1251'>\n";
$unjs_msg="\n\n<ul class='msg' id='unjs'><li>Javascript ,      .</li></ul>\n\n";
function head(){
 global $mypath, $doctype, $meta, $title, $metadescr, $css, $script, $uri_prfx, $scriptvis, $baseh, $addith, $cssrow, $jsrow, $page_script;
 $metadescr=($metadescr)?"<meta name='description' content='$metadescr'>\n":"";
 $baseh=($baseh)?"<base href='$baseh'>":"";
 $css=(!is_array($css))?array($css):$css;
 $script=(!is_array($script))?array($script):$script;
 $head="$doctype<html><head>\n$meta<title>$title</title>\n{$metadescr}$baseh\n";
 $style="";
 if ($cssrow) { /*    -    ..  css, js*/
  $cssrow=preg_split("/\s*\;\s*/", $cssrow);
  foreach ($cssrow as $crk=>$cr) {
   preg_match("/(\S+)\s*\<\=\s*inner/i", $cr, $crv);
//   print_r($crv); exit($cssrow[$crk]);
   if (isset($crv[1])) {
    $style.=implode("", file("$mypath/{$crv[1]}"));
    unset($cssrow[$crk]);
   }
  }
  $css = array_merge ($css, $cssrow);
 }
 $style=($style)?"<style type='text/css'>$style</style>":"";

 if ($page_script)
  $head.="<script type='text/javascript'>$page_script</script>\n";
 if ($jsrow) {
  $jsrow=preg_split("/\s*\;\s*/", $jsrow);
  $script = array_merge ($script, $jsrow);
 }
 foreach($css as $val) {
  if ($val) {
   $val=preg_replace("/^\//", "$uri_prfx/", $val);
   $head.="<link rel='stylesheet' href='$val' type='text/css'>\n";
  }
 }
 foreach($script as $val) {
  if ($val) {
   $val=preg_replace("/^\//", "$uri_prfx/", $val);
   $head.="<script type='text/javascript' src='$val'></script>\n";
  }
 }
 $head.="{$style}$addith\n</head>\n";
 return $head;
}

function checkcache() {
 global $uri, $match, $since, $h304;
 $normuri=addslashes(urldecode($uri));
 $sql="select `etag`, `time` from `pages` where `name`='$normuri'";
 $r=mysql_query($sql);
 $n=mysql_num_rows($r);
 if ($n) {
  $newetag=mysql_result($r,0,0);
  $newtime=mysql_result($r,0,1);
  if ($since==$newtime && $match==$newetag) {
   header($h304);
   exit;
  }
 }
}

function post2set($val="", $site="") {
 if (isset($_POST["set"])) $post =& $_POST["set"];
 else $post =& $_POST;
 $setstr="";
 foreach ($post as $k=>$v) {
  $j++; $comma=(1==$j)?"":", ";
  if (get_magic_quotes_gpc()) {
   $v=stripslashes($v);
  }
  if ($k==$site) {
   $v=preg_replace("/^(http\:\/\/)+/i", "", $v);
  }
  if ($k==$val) {
   $v=$v; //  
  }
  $kmy=str_replace("<","&lt;",$k);
  $vmy=str_replace("<","&lt;",$v);
  $kmy=mysql_real_escape_string($kmy);
  $vmy=mysql_real_escape_string($vmy);
  $setstr.="{$comma}`{$kmy}`='{$vmy}'";
 }
 return $setstr;
}

$uri_prfxsq=preg_quote($uri_prfxs, "/");
$fnam=preg_replace("/^".$uri_prfxsq."/", "", $uri);
$filenam="/{$fnam}";
//$hosting="dino";

/*======= constants ============*/
/* 1) minlen - -  ( ,  ) */
/* 2) menulimit - -      */
$fconst = "$pathacc/cadr.ini";
function fconst2arr($f, $div="=") {
 /*       ini 
 (   limit=300\n),  
 ( ,  =);   ()
      +   */
 global $const_form, $lang;
 $def=array(); //default || define
 if (!file_exists($f)) return $def;
 $file = explode("/", $f);
 $file = mysql_escape_string(array_pop($file));

 $lang = array();
 $sql = "select `file`, `name`, `val` from `lang` where `lang`='ru'";
 $r = mysql_query($sql);
 $n = @mysql_num_rows($r);
 if ($n) {
  while ($line = mysql_fetch_assoc($r)) {
   $filelang = $line['file'];
   $name = $line['name'];
   $val = $line['val'];
   if (!isset($lang["$filelang"])) $lang["$filelang"] = array();
   $lang["$filelang"]["$name"] = $val;
  }
 }
 $mylang = @$lang["$file"];
 $const_form="<form action='set_const.php' method='post' id='const'><table class='stru r'>";

 $div=preg_quote($div);
 $const=implode(file($f));
 $const=preg_split("/\r?\n/", $const);
 foreach($const as $v) {
  if ($v && strlen($v)>2) {
   $v=preg_split("/\s*$div\s*/", $v);
   $def["{$v[0]}"]=$v[1];
   $name = (isset($mylang) && isset($mylang["$v[0]"])) ? $mylang["$v[0]"] : $v[0];
   $const_form.="\n<tr><td>$name: </td><td><div class='rel'><input size='3' name='{$v[0]}' value='{$v[1]}'></div></td></tr>";
  }
 }
 $const_form.="\n<tr><td colspan='2'><input type='submit' value=' ' disabled='disabled'></td></tr></table></form>\n";
 return $def;
}
/*======= constants end ============*/

function boxes($sql, $name, $value_from) {
 global $postvis;
 $namevis=htmlspecialchars($name, ENT_QUOTES);
 $r=mysql_query($sql);
 if (!is_resource($r) || !mysql_num_rows($r))
  return;
 $tabres="<table class='region'>";
 $n=0;
 $nf=mysql_num_fields($r);
 while ($line = mysql_fetch_row($r)) {
  $tabres.="<tr>";
  for ($y=0; $y<$nf; $y++) {
   $val=htmlspecialchars($line[$y], ENT_QUOTES);
   $key=mysql_field_name($r, $y);
   if ($key==$value_from) $value=$val;
   $tabres.="<td>$val</td>";
  }
  $checked=(isset($postvis[$name]) && isset($postvis[$name][$n]))?"checked='checked' ":"";
  $tabres.="<td><input type='checkbox' {$checked}value='$value' name='{$namevis}[$n]'></td>";
  $tabres.="</tr>\n";
  $n++;
 }
 $tabres.="</table>\n";
 return $tabres;
}

function options($sql, $name) {
 $r=mysql_query($sql);
 if (!is_resource($r) || !mysql_num_rows($r))
  return;
 $tabres="<select name='$name'><option value='&#8211;'>&#8211;</option>\n";
 $selname=(isset($_POST[$name]))?intval($_POST[$name]):0;
 while ($line = mysql_fetch_row($r)) {
  $val=$line[0];
  $selected=($selname==$val) ? "selected='selected' " : "";
  $tabres.="<option {$selected}value='$val'>$val</option>\n";
 }
 $tabres.="</select>\n";
 return $tabres;
}

function ragngeinput($names=array(), $div="</p> <p>") {
 global $fieldru, $postvis; 
 if (!count($names)) return;
 foreach($names as $v) {
  $nameru=(isset($fieldru[$v]))?$fieldru[$v]:$v;
  $v1=(isset($postvis["$v"][1]))?htmlspecialchars($postvis["$v"][1], ENT_QUOTES):"";
  $v2=(isset($postvis["$v"][2]))?htmlspecialchars($postvis["$v"][2], ENT_QUOTES):"";
  $tabres[]="<span class='h4'>$nameru: $div</span>
<input name='{$v}[0]' type='hidden' value='range'> 
 <input name='{$v}[1]' class='wem4' value='{$v1}'> 
 <input name='{$v}[2]' class='wem4' value='{$v2}'>
\n";
 }
 $d2=explode(" ", $div);
 $tabres=$d2[1].implode($div, $tabres).$d2[0];
 return $tabres;
}
/*
 print_r($_POST);
 exit();
*/

function sql2arr($sql) {
 /*     ,    */
 $sqarr=array();
 $n=0;
 $r=mysql_query($sql);
 if (is_resource($r)) $n=mysql_num_rows($r);
 if (!$n) return $sqarr;
 while ($line = mysql_fetch_row($r)) {
  $sqarr["{$line[0]}"]=$line[1];
 }
 return $sqarr;
}

function post2where() {
 global $postsql;
 $whereseek="";
 if (!$postsql || !is_array($postsql)) return $whereseek;
 foreach($postsql as $k=>$v) {
 # $v=myaddslashes($v);
 # $k=myaddslashes($k);
  if (is_array($v) && count($v)) {
//   $g=$v[0] or exit("$k, $v, ".print_r($v));
   if (isset($v[0]) && "range"==$v[0]) {
    $whereseek.=" and `$k`>='".intval($v[1])."'";
    if ($v[2] && (intval($v[1])<=intval($v[2]))) {
     $whereseek.=" and `$k`<='".intval($v[2])."' ";
    }
    ${$k}=array(1=>$v[1], 2=>$v[2]); 
 //  print_r($v); exit("$k//".${$k}[1]."//");
   }
   else {
    $whereseek.=" and (`$k`='".implode("' or `$k`='", $v)."') ";
   }
  }
  else if (!preg_match("/^/", $v)){
   $v1=(preg_match("/^[\d\.\-]+$/", $v))?"='{$v}'":" like '%{$v}%'";
   $whereseek.=" and (`$k`{$v1}) ";
  }
 }
 return $whereseek;
}
